#include <stdio.h>
#include <Windows.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 


__declspec(dllexport) 
long WINAPI veryEncryptPDF(const char * inFileName, const char *outFileName, 
			   long EnctyptLen, long permission, 
			   const char *OwnerPassword, const char *UserPassword);
__declspec(dllexport) 
BOOL WINAPI veryTestEncryptedPDF(const char * inFileName,const char *OwnerPassword, 
				 const char *UserPassword);

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}



long GetPermission(BOOL Print,BOOL Copy,BOOL Modify,BOOL EnableAcroFormFields)
{
	long permission = 0;

	if(Print)
		permission |= 0x04;
	if(Copy)
		permission |= 0x10;
	if(Modify)
		permission |= 0x08;
	if(EnableAcroFormFields)
		permission |= 0x20;

	return permission;
}

void main()
{
	int encyptlevel,permission=0;
	char srcpath[_MAX_PATH];
	char despath[_MAX_PATH];
	BOOL m_bIsSucceed = FALSE;

	memset(srcpath,0,_MAX_PATH);
	memset(despath,0,_MAX_PATH);

	//example 1
	GetModulePath(srcpath,"test1.pdf");
	GetModulePath(despath,"test1Encrypt.pdf");
	encyptlevel=128;
	permission=GetPermission(TRUE,TRUE,TRUE,TRUE);
	veryEncryptPDF(srcpath,despath,encyptlevel,permission,"owner","user");
	m_bIsSucceed = veryTestEncryptedPDF(despath,"owner","user");

	//example 2
	GetModulePath(srcpath,"test2.pdf");
	GetModulePath(despath,"test2Encrypt.pdf");
	encyptlevel=40;
	permission=GetPermission(FALSE,FALSE,FALSE,FALSE);
	veryEncryptPDF(srcpath,despath,encyptlevel,permission,"owner","user");
	m_bIsSucceed = veryTestEncryptedPDF(despath,"owner","user");
}